structure Locate = 
struct

exception Exit_Loop

fun print_gap fid oc l1 l2 =
  let val ic = open_in fid
      val buff = ref ""
  in
    (while true do
      (let val str = input_line ic
       in 
         buff := (!buff)^(str^"\n")
       end) handle End_of_file => raise Exit_Loop
     end) handle Exit_Loop =>
     close_in ic;
     output_string oc (String.sub (!buff) (l1-1) (l2-(l1-1)))
  end

fun print_to_end fid oc l =
  let val ic = open_in fid
      val buff = ref ""
  in
    (while true do
      (let val str = input_line ic
       in 
         buff := (!buff)^(str^"\n")
       end) handle End_of_file => raise Exit_Loop
     end) handle Exit_Loop =>
     close_in ic;
     output_string oc (String.sub (!buff) (l-1) ((String.length (!buff))-l)) 
  end
(*
fun print_gap_st fid l1 l2 =
  let val ic = open_in fid
      val buff = ref ""
  in
    (while true do
      (let val str = input_line ic
       in 
         buff := (!buff)^(str^"\n")
       end) handle End_of_file => raise Exit_Loop
     end) handle Exit_Loop =>
     close_in ic;
     print_string (String.sub (!buff) (l1-1) (l2-(l1-1)))
  end
*)  
(*
fun print_line fid l1 l2 =
  let val ic = open_in fid
      val buff = ref []
      fun find_line buf a b line =
        case buf of
          [] => print_int line
        | hd::tl => let val hdlen = (String.length hd)+1
                    in
                      if (a>hdlen)
                        then find_line tl (a-hdlen) (b-hdlen) (line+1)
                        else (print_int (line+1);
                              print_string " (";
                              print_int a;
                              print_string ",";
                              print_int b;
                              print_string ")")
                    end
  in
    (while true do
      (let val str = input_line ic
           val len = String.length str
       in 
         buff := str::(!buff)
       end) handle End_of_file => raise Exit_Loop
     end) handle Exit_Loop =>
     close_in ic;
     find_line (List.rev (!buff)) l1 l2 0
  end 
*)     
end

